

using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using IRaCIS.Core.Domain.Share.Reading;

namespace IRaCIS.Core.Domain.Models
{
	///<summary>
	/// 临床资料
	///</summary>
	[Table("ReadingPeriodSite")]
	public class ReadingPeriodSite : Entity, IAuditAdd
	{

		/// <summary>
		///阅片期配置ID
		/// </summary>
		
		public Guid? ReadingPeriodSetId { get; set; }

		/// <summary>
		/// 中心ID
		/// </summary>
		public Guid? SiteId { get; set; }

		/// <summary>
		/// 创建时间
		/// </summary>
		public DateTime CreateTime { get; set; }

		/// <summary>
		/// 创建人
		/// </summary>
		public Guid CreateUserId { get; set; }

		public ReadingPeriodSet ReadingPeriodSet { get; set; }

		/// <summary>
		/// 中心
		/// </summary>
		public Site Site { get; set; }

	}


	



}
